/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#ifndef PREVIEWVIEW_H
#define PREVIEWVIEW_H
#include <Bitmap.h>
#include <View.h>
#include <Point.h>
#include <Window.h>
#include <Screen.h>
#include <ScrollBar.h>
class PreviewView : public BView
{
  public:
    PreviewView(BRect frame,BBitmap *bitmap,float zoom);
    virtual void Draw(BRect draw_rect);
    virtual void AttachedToWindow(void);
    virtual void FrameResized(float width,float height);
    
    void SetZoomScale(float);
    float ZoomScale();
    
    void SetBitmap(BBitmap *);
    BBitmap *Bitmap();
    
    void Update();
    
  private:
	void GetMaxSize(float *maxx, float *maxy);		// done
    void FixupScrollbars(void); 					// done
  private:
    BBitmap *fbitmap;
    float   fzoomscale;
};
#endif