/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#ifndef USERDEFINEPAGEDLG_H
#define USERDEFINEPAGEDLG_H
#include <Window.h>
#include <TextControl.h>
#include <Button.h>
#include <Message.h>
#include <Box.h>
#include <StringView.h>
#include <OS.h>
#include <Alert.h>
#include <stdio.h>
#include <PrinterInfo.h>

#include "GUIUtils.h"
namespace UserDefinePageDlgSpace
{
  const int32 DEF_WIDTH  		= 200;
  const int32 DEF_HEIGHT		= 115;
  
  const char  LB_PAGE_WIDTH[]	= "Width: ";
  const char  LB_PAGE_HEIGHT[]	= "Height: ";
  
  const char  LB_CANCEL[]		= "Discard";
  const char  LB_OK[]			= "Save";
  

  const uint32 MSGCODE_PAGE_WIDTH	= 'MSG0';
  const uint32 MSGCODE_PAGE_HEIGHT	= 'MSG0' + 1;
  const uint32 MSGCODE_OK			= 'MSG0' + 2;
  const uint32 MSGCODE_CANCEL		= 'MSG0' + 3;
};
class UserDefinePageDlg : public BWindow
{
  public:
    UserDefinePageDlg(uint8 unit,float ppage_min_width,float ppage_min_height,float ppage_max_width,float ppage_max_height,BMessage *msg,BLooper *target);
    virtual ~UserDefinePageDlg();
    void SetTo(float width,float height);
    float page_min_width;
    float page_min_height;
    float page_max_width;
    float page_max_height;
  protected:
    virtual void MessageReceived(BMessage *);		// done
  private:
    void BuildGUI();						// done
    void OnOK();							// done
    void OnCancel();						// done
    
    void OnPageWidthChange();				// done	
    void OnPageHeightChange();				// done
    void FixFloatString(BTextControl *);	// done
    float GetPageWidth();		// not
    float GetPageHeight();		// not
    
  private:
    BMessage *fmsg;
    BLooper  *ftarget;
    uint8 funit;
    BTextControl *tf_width;
    BTextControl *tf_height;
    BButton *btn_cancel;
    BButton *btn_ok;
};
#endif