/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include <InkLevelGroup.h>
InkLevelGroup::InkLevelGroup(int inks)
:BList(inks)
{
  for (int i = 0;i < inks;i++)
  BList::AddItem(new InkLevelItem());
} 
InkLevelGroup::~InkLevelGroup()
{
  for (int i = 0;i < BList::CountItems();i++)
  delete (InkLevelItem *) BList::ItemAt(i);
  BList::MakeEmpty();
}   
void InkLevelGroup::ItemLevel(int item_index,float value)const
{
  InkLevelItem *item = (InkLevelItem *) BList::ItemAt(item_index);
  if (item != NULL)
  item->Level(value); 
}
float InkLevelGroup::ItemLevel(int item_index)const
{
  InkLevelItem *item = (InkLevelItem *) BList::ItemAt(item_index);
  if (item != NULL)
  return item->Level();
  return - 1.0f;
}    
void InkLevelGroup::ItemColor(int item_index,rgb_color value)const
{
  InkLevelItem *item = (InkLevelItem *) BList::ItemAt(item_index);
  if (item != NULL)
  item->Color(value); 
}
bool InkLevelGroup::ItemColor(int item_index,rgb_color *color)const
{
  InkLevelItem *item = (InkLevelItem *) BList::ItemAt(item_index);
  if (item != NULL)
  {
    *color = item->Color();
    return true;
  }
  return false;
}

int InkLevelGroup::CountInks(void)
{
  return BList::CountItems();
}
int InkLevelGroup::NextLowInk(float low_value,int index)
{
  for (int i = index;i < CountInks();i++)
  {
    InkLevelItem *item = (InkLevelItem *) BList::ItemAt(i);
    if (item->Level() <= low_value)
    return i;
  }
  return -1;
}