/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include "ScaleInfo.h"
ScaleInfo::ScaleInfo()
:fx_res(0),fy_res(0),fmax_res(0)
{

}
ScaleInfo::ScaleInfo(int64 xres,int64 yres)
{
  SetTo(xres,yres);
}
ScaleInfo::~ScaleInfo()
{

}

void ScaleInfo::SetTo(int64 xres,int64 yres)
{
  fx_res = xres;
  fy_res = yres;

  if (fx_res > fy_res)
  fmax_res = fx_res;
  else
  fmax_res = fy_res;
  
  fdraw_scale = fmax_res / 72.0f;  
}
void ScaleInfo::Unset()
{
  fx_res = fy_res = fmax_res = 0;
  fdraw_scale = 0.0f;
}
// ====================================================================
int64 ScaleInfo::XResolution()const
{
  return fx_res;
}
int64 ScaleInfo::YResolution()const
{
  return fy_res;
}
int64 ScaleInfo::Resolution()const
{
  return fmax_res;
}
// ====================================================================

// ====================================================================
float ScaleInfo::DrawScale()const
{
  return fdraw_scale;
}
// ====================================================================

// ====================================================================
BRect ScaleInfo::NonScaleToDrawScale(BRect rect)
{
  BRect output;
  output.left   = NonScaleXToDrawScale(rect.left );
  output.right  = NonScaleXToDrawScale(rect.right);
  output.top    = NonScaleYToDrawScale(rect.top);
  output.bottom = NonScaleYToDrawScale(rect.bottom);
  return output;
}
    
BRect ScaleInfo::DrawScaleToNonScale(BRect rect)
{
  BRect output;
  output.left   = DrawScaleXToNonScale(rect.left);
  output.right  = DrawScaleXToNonScale(rect.right);
  output.top    = DrawScaleYToNonScale(rect.top);
  output.bottom = DrawScaleYToNonScale(rect.bottom);
  return output;
}
// ====================================================================

// ====================================================================
float ScaleInfo::NonScaleXToDrawScale(float x)const
{
  return (x * fdraw_scale);
}
float ScaleInfo::NonScaleYToDrawScale(float y)const
{
  return (y * fdraw_scale);
}
// ====================================================================

// ====================================================================
float ScaleInfo::DrawScaleXToNonScale(float x)const
{
  return (float) (x / fdraw_scale);
}
float ScaleInfo::DrawScaleYToNonScale(float y)const
{
  return (float) (y / fdraw_scale);
}
// ====================================================================

// ====================================================================