/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#ifndef SPOOLFILE_H
#define SPOOLFILE_H
#include <View.h>
#include <Entry.h>
#include <List.h>
#include <Bitmap.h>
#include <Region.h>

#include <PictureSpool.h>
#include <SpoolFileHeader.h>

class PreviewSpoolBitmap;

class SpoolFile : public SpoolFileHeader
{
  public:
    SpoolFile();															// done
    ~SpoolFile();															// done
    bool SetTo(BFile *spoolfile);											// done
    void Unset();															// done
    void ReadPreviewPage(int page_index,PreviewSpoolBitmap *);				// done
    
    PictureSpool *GetPicture(int);
    int32        CountPictures();
        
  private:
    inline void ToBW(rgb_color& color);
    
    void ConvertToBW(BBitmap *bitmap);										// done
    
    void FlipImage180(BBitmap *des_bitmap,BBitmap *src_bitmap);				// done
    void FlipImage180ToBW(BBitmap *des_bitmap,BBitmap *src_bitmap);			// done
    
    void FlipImage90(BBitmap *des_bitmap,BBitmap *src_bitmap);				// done
    void FlipImage90ToBW(BBitmap *des_bitmap,BBitmap *src_bitmap);			// done
    
    void FlipImage270(BBitmap *des_bitmap,BBitmap *src_bitmap);				// done
    void FlipImage270ToBW(BBitmap *des_bitmap,BBitmap *src_bitmap);			// done
  private:
    BFile *ffile;
    BList *fpiclist;
    friend class PartialSpool;
};
class PreviewSpoolBitmap
{
  public:
    PreviewSpoolBitmap(SpoolFile *);
    ~PreviewSpoolBitmap();
    BBitmap *Bitmap()const;
    friend class SpoolFile;
  private:
    BBitmap *fbitmap;   
};
#endif