#include "Addon.h"
#include <Alert.h>
#include <RasterSpool.h>
#include <TranslationKit.h>
#include <Window.h>
#include "PartialPreviewWindow.h"
void Msg(const char *str)
{
  BAlert *myalert = new BAlert(str,str,"OK");
  myalert->Go();
}
void MsgRect(const char *str,BRect rect)
{
  BString text;
  text << "rect " << str << "=[" << rect.left << "," << rect.top << "," << rect.right << "," << rect.bottom << "]";
  BAlert *myalert = new BAlert(text.String(),text.String(),"OK");
  myalert->Go();
}

printer_utility_return_t nozzlecheck(PrinterInfo *printer_info)
{
  Msg("nozzlecheck");
  return PRINTER_OK;
}
printer_utility_return_t headclean(PrinterInfo *printer_info)
{
  Msg("headclean");
  return PRINTER_OK;
}
printer_utility_return_t changecartridge(PrinterInfo *printer_info)
{
  Msg("change cartridge");
  return PRINTER_OK;
}
bool inkinfo(PrinterInfo *printer_info,InkLevelGroup *inklevel)
{
  rgb_color color;
  color.red = color.green = color.blue = 0;
  color.red = 255;
  // set the ink color for item 0 to red 
  inklevel->ItemColor(0,color);
  
  color.red = color.green = color.blue = 0;
  color.green = color.red = 255;
  // set the ink color for item 1 to yellow 
  inklevel->ItemColor(1,color);

  color.red = color.green = color.blue = 0;
  color.blue = 255;
  // set the ink color for item 2 to blue
  inklevel->ItemColor(2,color);

  color.red = color.green = color.blue = 0;
  // set the ink color for item 3 to black
  inklevel->ItemColor(3,color);
  return true;
}
printer_utility_return_t inklevel(PrinterInfo *printer_info,InkLevelGroup *inklevel)
{
  for (int i = 0;i < inklevel->CountInks();i++)
  // filling inklevel of each ink item .. value 0.0 .. 1.0
  inklevel->ItemLevel(i,1.0f);
  return PRINTER_OK;
}
printer_utility_return_t printdoc(PrinterInfo *printer_info,SpoolFile *spool_file)
{
  int i;
  BString str;
  Msg("Printing document");

  RasterSpool *raster = new RasterSpool();
  
  if (raster->Init(spool_file,600));
  {
    if (spool_file->ReverseOrder())
    {
      for (i = spool_file->PrintFileHeader().page_count;i > 0;i--)
      {
        raster->SetToPage(i);
        str = "";
        str << "Scan Page " << i;
        Msg(str.String());
        while (raster->ScanNext())
        {
          PartialPreviewWindow *win = new PartialPreviewWindow(BRect(100,200,300,500),raster->Bitmap());
          win->Go();
        }
        str = "";
        str << "End of scan page " << i;
        Msg(str.String());
      }
    }
    else
    {
      for (i = 1;i <= spool_file->PrintFileHeader().page_count;i++)
      {
        raster->SetToPage(i);
        str = "";
        str << "Scan Page " << i;
        Msg(str.String());
        while (raster->ScanNext())
        {
          PartialPreviewWindow *win = new PartialPreviewWindow(BRect(100,200,300,500),raster->Bitmap());
          win->Go();
        }
        str = "";
        str << "End of scan page " << i;
        Msg(str.String());
      }
    }
  }
  delete raster;  
  // for raster printer addon 
  // create a RasterSpool from spool_file
  // else
  // you can retrieve the BPicture by calling spool_file->GetPicture(pagenumber);
  // note page number is 1 ... total_page 
  return PRINTER_OK;
}
