#include "PartialPreviewWindow.h"
PartialPreviewWindow::PartialPreviewWindow(BRect frame,BBitmap *bitmap)
:BWindow(frame,"PartialPreview",B_DOCUMENT_WINDOW,B_CURRENT_WORKSPACE)
,fsem(-1)
{
  fsem = create_sem(0,"PartialPreview");

  BRect preview_rect;
  preview_rect = Bounds();
  preview_rect.right -= B_V_SCROLL_BAR_WIDTH;
  preview_rect.bottom -= B_H_SCROLL_BAR_HEIGHT;
  PartialPreviewView *fpreviewview = new PartialPreviewView(preview_rect,bitmap);
  
  AddChild(new BScrollView("ImageScroll", fpreviewview, B_FOLLOW_ALL_SIDES, B_WILL_DRAW, true, true));
}
PartialPreviewWindow::~PartialPreviewWindow()
{
  if (fsem >= B_OK)
  {
    delete_sem(fsem);
  }
}
void PartialPreviewWindow::Go()
{
  Lock();
  Show();
  Unlock();
  
  acquire_sem(fsem);
  
  Lock();
  Quit();
}
bool PartialPreviewWindow::QuitRequested(void)
{
  if (fsem >= B_OK)
  {
    release_sem(fsem);
  }
  return true;
}
